import es
import random, cfglib, popuplib, gamethread, playerlib, usermsg
from os.path import isfile

import psyco
psyco.full()

config = cfglib.AddonCFG(es.getAddonPath('bdm') + '/bdm_config.cfg')

config.text('*****************************************')
config.text("* BackRaw's Deathmatch V2 Configuration *")
config.text('*****************************************')
config.text('\n')
config.text('* General *')
respawn = config.cvar('bdm_respawn', .75, 'Respawning Time')
respawn_protection = config.cvar('bdm_respawn_protection', 2, 'How long to protect players? 0 = Off')
awp = config.cvar('bdm_awp', 1, 'Enable AWP?')
auto = config.cvar('bdm_autosnipers', 1, 'Enable Autosnipers?')
ff = config.cvar('bdm_ff', 0, 'Enable/Disable Friendly Fire')
protectioncolor_t = config.cvar('bdm_spawnprotectioncolor_t', '255, 0, 0, 105', 'Set the protection-color for Terrorists')
protectioncolor_ct = config.cvar('bdm_spawnprotectioncolor_ct', '0, 0, 255, 105', 'Set the protection-color for Counter-Terrorists')
refill = config.cvar('bdm_refillammo', 1, 'Should ammunition be refilled?')
config.text('\n')
config.text('* Show Damage *')
sd = config.cvar('bdm_showdamage', 1, 'Enable/Disable Show Damage')
config.text('\n')
config.text('* Bot Weapons *')
bot_sec = config.cvar('bdm_bot_sec', 'glock,usp,p228,deagle,fiveseven,elite', 'Setup Bot Secondary Weapons')
bot_prim = config.cvar('bdm_bot_prin', 'ak47,m4a1,p90,mp5navy,m249,famas,galil', 'Setup Bot Primary Weapons')
config.text('\n')
config.text('* Extras *')
spawns = config.cvar('bdm_spawn', 1, 'Use (not really good) spawnpoints?')
noblock = config.cvar('bdm_noblock', 1, '1 = Disable blocking 0 = Enable blocking')
unlhe = config.cvar('bdm_unlimited_he', 1, 'Unlimited HE-Grenades?')
config.text('\n')
config.text('*********************************************')
config.text("* BackRaw's Deathmatch V2 Configuration End *")
config.text('*********************************************')

config.write()

players = {}
menu = menu_sec = menu_prim = map_spawns = 0
if spawns == 1:
    spoints = []
rsec = ['glock', 'usp', 'p228', 'deagle', 'fiveseven', 'elite']
rprim = ['m4a1', 'ak47', 'famas', 'galil', 'm3', 'xm1014', 'tmp', 'mac10', 'ump45', 'p90', 'mp5navy', 'aug', 'sg552', 'm249', 'scout']
if awp == 1 and not 'awp' in rprim:
    rprim.append('awp')
elif 'awp' in rprim:
    rprim.remove('awp')
if auto == 1:
    if not 'sg550' in rprim:
        rprim.append('sg550')
    if not 'g3sg1' in rprim:
        rprim.append('g3sg1')
else:
    if 'sg550' in rprim:
        rprim.remove('sg550')
    if 'g3sg1' in rprim:
        rprim.remove('g3sg1')

def load():
    global menu, menu_sec, menu_prim, spoints
    config.execute()
    es.ServerVar('bdm_ver', '2.0', "BackRaw's Deathmatch Version").makepublic()
    spoints = []
    es.server.queuecmd('mp_friendlyfire %s' % ff)
    es.doblock('corelib/noisy_on')
    menu = popuplib.easymenu('mainmenu', '_popup_choice', main)
    menu.settitle('Main Menu - Choose an Option')
    menu.addoption('new', 'New Equipment')
    menu.addoption('display', 'Same Weapons, display this menu again')
    menu.addoption('never', 'Same Weapons, never this menu display again')
    menu.addoption('random', 'Random Weapons')
    menu_sec = popuplib.easymenu('secmenu', '_popup_choice', secmen)
    menu_sec.settitle('Choose a Secondary Weapon')
    menu_sec.addoption('glock', 'Glock 18C')
    menu_sec.addoption('usp', 'USP')
    menu_sec.addoption('p228', 'P228 Compact')
    menu_sec.addoption('deagle', 'Deagle')
    menu_sec.addoption('fiveseven', 'ES FiveSeven')
    menu_sec.addoption('elite', 'Elite')
    menu_sec.addoption(0, 'None')
    menu_prim = popuplib.easymenu('primmenu', '_popup_choice', primmen)
    menu_prim.settitle('Choose a Primary Weapon')
    menu_prim.addoption('m4a1', 'Maverick M4A1')
    menu_prim.addoption('ak47', 'AK-47')
    if awp:
        menu_prim.addoption('awp', 'Artic Warfare Police (AWP)')
    menu_prim.addoption('scout', 'Steyr Scout')
    menu_prim.addoption('sg552', 'SG-552 Commando')
    menu_prim.addoption('galil', 'IMI Galil')
    menu_prim.addoption('famas', 'Famas')
    if auto:
        menu_prim.addoption('g3sg1', 'G3SG1 Auto Sniper')
        menu_prim.addoption('sg550', 'SG-550 Auto Sniper')
    menu_prim.addoption('aug', 'Steyr AUG')
    menu_prim.addoption('m249', 'M249 Para')
    menu_prim.addoption('ump45', 'Universal Mashine Pistol (UMP 45)')
    menu_prim.addoption('mp5navy', 'MP5-Navy')
    menu_prim.addoption('m3', 'M3 Super 90 Entry')
    menu_prim.addoption('xm1014', 'XM1014 (M4 Super 90)')
    menu_prim.addoption('tmp', 'Tactical Mashine Pistol (TMP)')
    menu_prim.addoption('mac10', 'Ingram MAC-10')
    menu_prim.addoption('p90', 'P90')
    menu_prim.addoption(0, 'None')
    if not es.exists('saycommand', 'guns'):
        es.regsaycmd('guns', 'bdm/guns')
    if not es.exists('clientcommand', 'guns'):
        es.regclientcmd('guns', 'bdm/guns')
    for userid in es.getUseridList():
        user = es.getplayersteamid(userid)
        if user != 'BOT' and not user in players:
            default(user)
        es.server.queuecmd('es_xfire %s func_buyzone Disable;es_xfire %s func_bomb_target Disable;es_xfire %s func_hostage_rescue Disable' % (userid, userid, userid))

def unload():
    for userid in es.getUseridList():
        es.server.queuecmd('es_xfire %s func_buyzone Enable;es_xfire %s func_bomb_target Enable;es_xfire %s func_hostage_rescue Enable' % (userid, userid, userid))
    menu.delete()
    menu_sec.delete()
    menu_prim.delete()
    es.unregsaycmd('guns')
    es.unregclientcmd('guns')
    players.clear()

def default(user):
    players[user] = {}
    players[user]['sec'] = 0
    players[user]['prim'] = 0
    players[user]['display'] = 0
    players[user]['random'] = 0

def es_map_start(ev):
    global spoints
    spoints = []

def guns():
    menu.send(es.getcmduserid())

def player_activate(ev):
    user = ev['es_steamid']
    if user != 'BOT':
        if user in players:
            del players[user]
            default(user)
        elif not user in players:
            default(user)

def player_team(ev):
    userid = ev['userid']
    if es.exists('userid', userid) and int(ev['es_userteam']) >= 2:
        es.delayed(2, 'est_Spawn ' + userid)

def player_spawn(ev):
    team = int(ev['es_userteam'])
    if team > 1:
        userid = int(ev['userid'])
        user = ev['es_steamid']
        player = playerlib.getPlayer(userid)
        if spawns == 1 and spoints:
            x, y, z = random.choice(spoints)
            es.server.queuecmd('es_xsetpos %s %s %s %s' % (userid, x, y, z))
        if user == 'BOT':
            strip_player(userid)
            randomweps(userid, user)
        else:
            if players[user]['random'] == 1:
                randomweps(userid, user)
            else:
                giveweps(userid, user)
                if players[user]['display'] in [0, 1]:
                    menu.send(userid)
        es.delayed(.1, 'es_xfire %s func_buyzone Disable;es_xfire %s func_bomb_target Disable;es_xfire %s func_hostage_rescue Disable' % (userid, userid, userid))
        es.delayed(.2, 'est_RemoveIdle weapon')
        if noblock == 1:
            es.setplayerprop(userid, 'CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup', 2)
        if respawn_protection:
            es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 0)
            if team == 2:
                es.server.queuecmd('es_xremove weapon_c4')
                player.set('color', str((protectioncolor_t)).split(','))
            else:
                player.set('color', str((protectioncolor_ct)).split(','))
            gamethread.delayed(respawn_protection, player.set, ('color', (255, 255, 255, 255)))
            gamethread.delayed(respawn_protection, es.setplayerprop, (userid, 'CBasePlayer.m_lifeState', 512))
            es.delayed(respawn_protection, 'es_xgive %s item_assaultsuit' % userid)
            gamethread.delayed(respawn_protection, es.setplayerprop, (userid, 'CBasePlayer.m_iHealth', 100))

def round_end(ev):
    for userid in es.getUseridList():
        menu.unsend(userid)

def player_hurt(ev):
    if sd == 1:
        dmg = ev['dmg_health']
        es.centertell(ev['attacker'], 'Damage Given: ' + dmg)
        usermsg.hudhint(ev['userid'], 'Damage Taken: ' + dmg)

def player_death(ev):
    userid = ev['userid']
    if spawns == 1:
        x, y, z = es.getplayerlocation(userid)
        spoints.append((x, y, z))
    weaponammo(int(ev['attacker']))
    es.server.queuecmd('est_RemoveIdle weapon')
    es.delayed(respawn, 'est_RemoveIdle cs_ragdoll')
    es.delayed(respawn, 'est_Spawn ' + userid)

def strip_player(userid):
    es.server.queuecmd('es_xfire %s player_weaponstrip kill' % userid)
    es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
    es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
    es.server.queuecmd('es_xgive %s item_assaultsuit;es_xgive %s weapon_knife' % (userid, userid))

def randomweps(userid, user):
    strip_player(userid)
    if user == 'BOT':
        es.delayed(0, 'es_xgive %s weapon_%s' % (userid, random.choice(str(bot_sec).split(','))))
        es.delayed(0, 'es_xgive %s weapon_%s' % (userid, random.choice(str(bot_prim).split(','))))
    else:
        es.delayed(0, 'es_xgive %s weapon_%s' % (userid, random.choice(rsec)))
        es.delayed(0, 'es_xgive %s weapon_%s' % (userid, random.choice(rprim)))
    es.delayed(0, 'es_xgive %s weapon_hegrenade' % userid)

def main(userid, choice, popupid):
    user = es.getplayersteamid(userid)
    if choice == 'new':
        default(user)
        menu_sec.send(userid)
    elif choice == 'random':
        default(user)
        players[user]['random'] = 1
        randomweps(userid, user)
    else:
        if choice == 'display':
            players[user]['display'] = 1
        elif choice == 'never':
            players[user]['display'] = 2
        if players[user]['sec'] or players[user]['prim']:
            giveweps(userid, user)
        else:
            default(user)
            menu_sec.send(userid)

def secmen(userid, choice, popupid):
    players[es.getplayersteamid(userid)]['sec'] = choice
    menu_prim.send(userid)

def primmen(userid, choice, popupid):
    user = es.getplayersteamid(userid)
    players[user]['prim'] = choice
    giveweps(userid, user)
    gamethread.delayed(0, menu.send, (userid))

def giveweps(userid, user):
    strip_player(userid)
    if players[user]['sec']:
        es.delayed(0, 'es_xgive %s weapon_%s' % (userid, players[user]['sec']))
    if players[user]['prim']:
        es.delayed(0, 'es_xgive %s weapon_%s' % (userid, players[user]['prim']))
    es.delayed(0, 'es_xgive %s weapon_hegrenade' % userid)

def weapon_fire(ev):
    if unlhe == 1 and ev['weapon'] == 'hegrenade':
        es.server.queuecmd('es_xgive %s weapon_hegrenade' % ev['userid'])

def weapon_reload(ev):
    if refill == 1:
        weaponammo(int(ev['userid']))

def weaponammo(userid):
    player = playerlib.getPlayer(userid)
    a = str(player.get('weapon')).replace('weapon_', '')
    if a == 'p228':
        player.set('ammo', ['secondary', '52'])
    elif a == 'deagle':
        player.set('ammo', ['secondary', '35'])
    elif a == 'awp':
        player.set('ammo', ['primary', '30'])
    elif a == 'm249':
        player.set('ammo', ['primary', '200'])
    elif a in ['glock', 'elite']:
        player.set('ammo', ['secondary', '120'])
    elif a in ['usp', 'fiveseven']:
        player.set('ammo', ['secondary', '100'])
    elif a in ['m4a1', 'ak47', 'galil', 'famas', 'sg552', 'aug', 'scout']:
        player.set('ammo', ['primary', '90'])
    elif a in ['m3', 'xm1014']:
        player.set('ammo', ['primary', '32'])
    elif a in ['tmp', 'mp5navy']:
        player.set('ammo', ['primary', '120'])
    elif a in ['mac10', 'ump45', 'p90']:
        player.set('ammo', ['primary', '100'])
